﻿<script type="text/javascript">


// Запускаем только после отстройки DOM
$().ready(function() {

	// Инициализируем автодополнение. Здесь задаём только общие для всех запросов параметры
	$("#X_S21STR").autocomplete(cgi, {		
		multipleSeparator: " ",
		cacheLength: 0,		
		matchSubset: false,	
		scrollHeight: 350
	});
	
	// Обрабатываем переключение области поиска. Событие также генерируется при загрузке страницы
	$('#X_S21P03').change(function() {
			// Определяем текущее значение выпадающего списка с префиксами
			var prf=$(this).val();			
			// Устанавливаем параметры автодополнения для текущего случая.
			$("#X_S21STR").setOptions({
				multiple: ((prf=='<? &uf('IMAIN,keywords_prefix,K=') ?>') ? true : false),
				// Здесь задаются параметры, которые мы хотим видеть в запросе для получения словаря
				extraParams: {
					   T21CNR: '10',
					   C21COM: 'T',
					   T21PRF: prf,
					   I21DBN: $("#P21DBN").val()
				}		
			});	
	
	});	
	
	// Имитируем изменение списка с префиксами при загрузке страницы (чтобы нам не плодить лишние функции :))
	$('#X_S21P03').trigger( "change" );

	// Ставим обработчик на отправку формы
	$('#SEARCH').submit(function() {
		// Если в форме есть и установлен флажок поиска в найденном
		var searchIn=$('#searchIn:checked').length;
		var prf=$('#X_S21P03').val();
		
		//===== Значения параметров поиска по умолчанию. Могут быть полезны при возврате назад =====
		// Термином является фраза целиком
		document.SEARCH.X_S21LOG.value = "2";			
		// Текст как термин
		document.SEARCH.X_S21P01.value = "0";
		// Усечение применяем. Для года позволяет 
		document.SEARCH.X_S21P02.value = "1";
		// Квалификаторы не используем
		document.SEARCH.X_S21P04.value = "";
		
		//\===== Значения параметров поиска по умолчанию =====
		
		switch ( prf ) { 
			case "<? &uf('IMAIN,keywords_prefix,K=') ?>": 
				// Слова, связанные логикой И
				document.SEARCH.X_S21LOG.value = "1";
				// Если мы хотим добавить уточнение по ключевым словам к полнотекстовому запросу или используется ИРБИС 32... 
				if (searchIn || <? &uf('IMAIN,GENERATION,') ?>==32)
					document.SEARCH.X_S21P01.value = "3";			
					else 
					document.SEARCH.X_S21P01.value = "4";			
			break; 

			case "G=": 
			// Берём значение до пробела
				document.SEARCH.X_S21P01.value = "1";										
			break; 

			case "A=": 
				var author_normalized=add_comma($("#X_S21STR").val());
				// Если нормализация не была проведена, выполняем поиск данным об авторе в ключевых словах 
				if (author_normalized==$("#X_S21STR").val()){
					document.SEARCH.X_S21LOG.value = "1";
					document.SEARCH.X_S21P01.value = "1";					
					document.SEARCH.X_S21P02.value = "0";	
					document.SEARCH.X_S21P04.value = "700";					
					$('#X_S21P03').val("K=");					
				}else {
					// Если нормализация прошла, норализуем значение данных об авторе
					$("#X_S21STR").val(author_normalized);
				}
			break; 
			
			default:
			// По умолчанию (заглавие, автор) весь текст -- термин
				document.SEARCH.X_S21P01.value = "0";
		}


		
		return true;	
	});	

    /**
     * add_comma
     * Функция нормализации данных об авторе с инициалами. Добавляет запятую после автора и пробелы между инициалами.
     * @param author_string  -- строка, содержащая формулировку данных об авторе, введённую пользователем
     * @return -- результат нормализации данных об авторе или исходная версия строки, если основания для нормализации не найдены.
     */	
	var add_comma=function(author_string){
		//re=new RegExp("(?:([A-zА-я\\-\\']{2,})\\,? ([A-zА-я])\\. ?(\\-?[A-zА-я]?)\\.?)|(?:([A-zА-я])\\. ?(\\-?[A-zА-я]?)\\.? ([A-zА-я\\-\\']{2,}))"); 		
		re=new RegExp("(?:([A-zА-я\\-\\']{2,})\\,? ([A-zА-я])\\. ?(\\-?[A-zА-я]?)\\.?)|(?:([A-zА-я])\\. ?(?:(\\-?[A-zА-я])\\.)? ?([A-zА-я\\-\\']{2,}))"); 

		if (re.exec(author_string)){
			var last_initial=RegExp.$3+RegExp.$5;					
			return (RegExp.$1+RegExp.$6+", "+RegExp.$2+RegExp.$4+"."+(last_initial ? " "+last_initial+"." : ""));
		}		
		return author_string; 		
	}
	
	/* 
	Отладочный код для функции add_comma, демонстрирующий обработку различных вариантов написания данных об авторе. 
	Результат отображается в консоле браузера (кнопка F12) 
	*/
	console.log(add_comma("иванов и.а."));
	console.log(add_comma("иВанОв, И.а."));
	console.log(add_comma("иванов И."));	
	console.log(add_comma("и. иванов"));	
	console.log(add_comma("и.а. иванов"));
	console.log(add_comma("и. а. иванов"));		
	console.log(add_comma("д'артаньян и.и."));
	console.log(add_comma("мольер ж.-б."));
	console.log(add_comma("иванов иван иванович"));
	console.log(add_comma("ким чен ир"));
	
});


</script>



<center>



<table width=100% style="border:1px solid #99ccff;font-size:x-small;margin-bottom:0px" cellspacing="5" cellpadding="5" background="<--HTTP_PATH-->/images/searchbackground.gif">
<tr>
<td>


<form name="SEARCH" id="SEARCH" action="<--CGI_PATH-->" enctype="Multipart/form-data" method="POST" >

<TABLE BORDER=0 width=100% class="advanced">
             
            <tr>
              <th width="80%">
~~Область поиска~~
              </th>
            </tr>
             
            <tr>
              <td valign="Center" width="100%">
              <select name="X_S21P03" id="X_S21P03" style="width: 90%;"   >
              <option value="K="> ~~Ключевые слова~~<?! if &uf('IMAIN,GENERATION,')<>'32' then ' (~~ВЕЗДЕ~~)' fi ?></option>
              <option value="A="> ~~Автор~~ </option>
              <option value="T="> ~~Заглавие~~ </option>
              <option value="G="> ~~Год издания~~ </option>
              </select>
              </td>
            </tr>

<TR><TD>




<input type="hidden" name="I21DBN"  value="<?,v2221,?>">
<input type="hidden" name="P21DBN" id="P21DBN" value="<?,v3331,?>">

<input type="hidden" name="LNG" value="<?,v5500,?>">

<input style="width: 90%; " name="X_S21STR" id="X_S21STR"  title='~~Если при поиске по автору Вы хотите указать инициалы, то после фамилии следует поставить "запятую". Например: Иванов, А. И.~~'>

<input type="hidden" name="X_S21P01" value="1">
<input type="hidden" name="X_S21P02" value="1">
<input type="hidden" name="X_S21P04" value="">
<input type="hidden" name="X_S21LOG" value="1">

<input type="hidden" name="S21COLORTERMS" value="1">
<input type="hidden" name="S21FMT" value="fullwebr">
<input type="hidden" name="S21STN" value="1">
<input type="hidden" name="S21CNR" value="10">
<input type="hidden" name="S21REF" value="3">
<input type="hidden" name="FT_MORPHOLOGY" value="1">
<input type="hidden" name="FT_NEARLEVEL" value="5">


<?if (v2225<>'') then '<input type="hidden" name="Z21ID" value="',&uf('+3E',v2225),'">'?>


</TD>

<TD> 
<input type="hidden" name="C21COM" value="S">
<input type="submit" name="C21COM1" value="~~Поиск~~">

</TD></TR>
</TABLE>
</form>



</td>
</tr>
</table>
</CENTER>








<!FORMAT=@web_news_all_1>

<a style="cursor:hand; color:blue; font-size:20px; text-decoration:none;"  href="#ParamHelp"    onclick="javascript:DropDown('ParamHelp');">
 <h4>~~Правила составления запроса при поиске~~  ?
</h4>   
</a>


<div style="font-size:10pt; display:none" id="ParamHelp">
<p>
~~Выбрав необходимую область поиска (ключевые слова, автор, заглавие, год издания), введите запрос в поле ввода~~:
<ul>
<li><p>~~При поиске~~ <strong>~~по ключевым словам~~</strong> (полнотекстовый поиск) - ~~фразу на естественном языке.~~ 
~~Фраза разбирается на отдельные слова, 
~~которые морфологически нормализуются (только для русских слов~~!).
~~При полнотекстовом поиске применяется алгоритм ранжирования найденных документов~~: ~~список результатов поиска сортируется в порядке убывания ранга документа.~~
~~Чем больше в найденном документе слов из запроса, чем эти слова ближе друг к другу и чем больше их суммарный вес~~ - ~~тем выше место документа в результате поиска.~~<p>
~~Ссылка~~ "~~Найти похожие~~", ~~которая показывается  в библиографическом описании найденных записей,~~
~~формирует запрос на ранжированный поиск,~~
~~включающий все ключевые слова записи.~~
<p>
</li>

<li>~~При поиске~~ <strong>~~по автору или заглавию~~</strong> - ~~фамилию или начало заглавия (в случае если оно точно известно).~~
~~В этом случае следует вводить только одного автора (или одно заглавие).~~
 <span style="color:red"> Если при поиске по автору Вы хотите указать инициалы, то после фамилии следует поставить "запятую". Например: Иванов, А. И.</span>
 
</li>
<li>
~~При поиске~~ <strong>~~по году~~</strong> - ~~год издания (четырехзначное число).~~
</li>

</ul>
~~Получив результат поиска, Вы сможете таким же образом~~ "~~уточнить~~" ~~Ваш запрос (искать в найденном).~~</p>

</font>

</div>

