﻿
<script type="text/javascript">


// Запускаем только после отстройки DOM
$().ready(function() {

	// Инициализируем автодополнение. Здесь задаём только общие для всех запросов параметры
	$("#X_S21STR").autocomplete(cgi, {		
		multipleSeparator: " ",
		cacheLength: 0,		
		matchSubset: false,	
		scrollHeight: 350
	});
	
	// Обрабатываем переключение области поиска. Событие также генерируется при загрузке страницы
	$('#X_S21P03').change(function() {
			// Определяем текущее значение выпадающего списка с префиксами
			var prf=$(this).val();			
			// Устанавливаем параметры автодополнения для текущего случая.
			$("#X_S21STR").setOptions({
				multiple: ((prf=='<? &uf('IMAIN,keywords_prefix,K=') ?>') ? true : false),
				// Здесь задаются параметры, которые мы хотим видеть в запросе для получения словаря
				extraParams: {
					   T21CNR: '10',
					   C21COM: 'T',
					   T21PRF: prf,
					   I21DBN: $("#P21DBN").val()
				}		
			});	
	
	});	
	
	// Имитируем изменение списка с префиксами при загрузке страницы (чтобы нам не плодить лишние функции :))
	$('#X_S21P03').trigger( "change" );

	// Ставим обработчик на отправку формы
	$('#SEARCH').submit(function() {
		// Если в форме есть и установлен флажок поиска в найденном
		var searchIn=$('#searchIn:checked').length;
		var prf=$('#X_S21P03').val();
		
		//===== Значения параметров поиска по умолчанию. Могут быть полезны при возврате назад =====
		// Термином является фраза целиком
		document.SEARCH.X_S21LOG.value = "2";			
		// Текст как термин
		document.SEARCH.X_S21P01.value = "0";
		// Усечение применяем. Для года позволяет 
		document.SEARCH.X_S21P02.value = "1";
		// Квалификаторы не используем
		document.SEARCH.X_S21P04.value = "";
		
		//\===== Значения параметров поиска по умолчанию =====
		
		switch ( prf ) { 
			case "<? &uf('IMAIN,keywords_prefix,K=') ?>": 
				// Слова, связанные логикой И
				document.SEARCH.X_S21LOG.value = "1";
				// Если мы хотим добавить уточнение по ключевым словам к полнотекстовому запросу или используется ИРБИС 32... 
				if (searchIn || <? &uf('IMAIN,GENERATION,') ?>==32)
					document.SEARCH.X_S21P01.value = "3";			
					else 
					document.SEARCH.X_S21P01.value = "4";			
			break; 

			case "G=": 
			// Берём значение до пробела
				document.SEARCH.X_S21P01.value = "1";										
			break; 

			case "A=": 
				var author_normalized=add_comma($("#X_S21STR").val());
				// Если нормализация не была проведена, выполняем поиск данным об авторе в ключевых словах 
				if (author_normalized==$("#X_S21STR").val()){
					document.SEARCH.X_S21LOG.value = "1";
					document.SEARCH.X_S21P01.value = "1";					
					document.SEARCH.X_S21P02.value = "0";	
					document.SEARCH.X_S21P04.value = "700";					
					$('#X_S21P03').val("K=");					
				}else {
					// Если нормализация прошла, норализуем значение данных об авторе
					$("#X_S21STR").val(author_normalized);
				}
			break; 
			
			default:
			// По умолчанию (заглавие, автор) весь текст -- термин
				document.SEARCH.X_S21P01.value = "0";
		}
		
		// Если поиск в найденном не включён, то очищаем поля формы, связанные с текущим запросом		
		
		if (!searchIn){			
				document.SEARCH.S21ALL.value="";
				document.SEARCH.FT_REQUEST.value="";
				document.SEARCH.FT_PREFIX.value="";								 
		}
		
		return true;	
	});	


    /**
     * add_comma
     * Функция нормализации данных об авторе с инициалами. Добавляет запятую после автора и пробелы между инициалами.
     * @param author_string  -- строка, содержащая формулировку данных об авторе, введённую пользователем
     * @return -- результат нормализации данных об авторе или исходная версия строки, если основания для нормализации не найдены.
     */	
	var add_comma=function(author_string){
		//re=new RegExp("(?:([A-zА-я\\-\\']{2,})\\,? ([A-zА-я])\\. ?(\\-?[A-zА-я]?)\\.?)|(?:([A-zА-я])\\. ?(\\-?[A-zА-я]?)\\.? ([A-zА-я\\-\\']{2,}))"); 		
		re=new RegExp("(?:([A-zА-я\\-\\']{2,})\\,? ([A-zА-я])\\. ?(\\-?[A-zА-я]?)\\.?)|(?:([A-zА-я])\\. ?(?:(\\-?[A-zА-я])\\.)? ?([A-zА-я\\-\\']{2,}))"); 

		if (re.exec(author_string)){
			var last_initial=RegExp.$3+RegExp.$5;					
			return (RegExp.$1+RegExp.$6+", "+RegExp.$2+RegExp.$4+"."+(last_initial ? " "+last_initial+"." : ""));
		}		
		return author_string; 		
	}
	
});





</script>

<table width=100% style="border:1px solid #99ccff;font-size:x-small;margin-bottom:10px" cellspacing="5" cellpadding="5" background="<--HTTP_PATH-->/images/searchbackground.gif">
<tr>
<td>

<TABLE BORDER=0 width=100% class="advanced">
<form name="SEARCH" id="SEARCH" action="<--CGI_PATH-->" enctype="Multipart/form-data" method="POST" >
            <tr>
              <th width="80%">
              ~~Область поиска~~
              </th>
            </tr>


            <tr>
              <td valign="Center" width="100%">
              <select name="X_S21P03" id="X_S21P03" style="width: 100%;"  >
<?!'<option value="K="' ,if v3414:'K'  then 'selected=""' fi,' > ~~Ключевые слова (ВЕЗДЕ)~~</option>'?>
<?!'<option value="A="' ,if v3414: 'A'  then 'selected=""' fi,' > ~~Автор~~</option>'?>
<?!'<option value="T="' ,if v3414:'T' then 'selected=""' fi,' > ~~Заглавие~~</option>'?>
<?!'<option value="G="' ,if v3414:'G' then 'selected=""' fi,' >~~Год издания~~</option>'?>              </select>
              </td>
            </tr>

<?!if val(v1001)>val(v2224)  then '<tr><td><b>~~в найденном~~</b><input type="checkbox" value="" name="SearchIn" id="searchIn"></td></tr>', else '<input type="hidden" value="" name="SearchIn" id="searchIn">' fi?>
<TR><TD>

<? (if v3413<>'' then '<input type=','"','hidden','"',' name=','"','R21DBN','"','value=','"',v3413,'">'/, else break fi) ?>

<input type="hidden" name="I21DBN"  value="<?,v2221,?>">
<input type="hidden" name="P21DBN" id="P21DBN" value="<?,v3331,?>">

<input type="hidden" name="LNG" value="<?,v5500,?>">


<input style="width: 90%; " name="X_S21STR" id="X_S21STR"  title='~~Если при поиске по автору Вы хотите указать инициалы, то после фамилии следует поставить "запятую". Например: Иванов, А. И.~~'>
<input type="hidden" name="X_S21P01" value="1">
<input type="hidden" name="X_S21P02" value="1">
<input type="hidden" name="X_S21P04" value="">
<input type="hidden" name="X_S21LOG" value="1">


<input type="hidden" name="S21COLORTERMS" value="1">
<input type="hidden" name="S21STN" value="1">
<input type="hidden" name="S21REF" value="1">

<?if v1009<>'' then  '<input type="hidden" name="S21FMT" value="' v1009 '">' fi?>
<?if v1010<>'' then  '<input type="hidden" name="S21REF" value="' v1010 '">' fi?>
<?if v2224<>'' then  '<input type="hidden" name="S21CNR" value="' v2224 '">' fi?>

<input type="hidden" name="S21REF" value="10">
<?if (v2225<>'') then '<input type="hidden" name="Z21ID" value="',&uf('+3E',v2225),'">' fi?>
<?'<input type="hidden" name="S21ALL" value="',if val(v1001) > val(v2224)  then ,&uf('+3E', if &uf('IMAIN,GENERATION,')='32' then &uf('+3U',v2226) else v2226 fi ) fi,'">'?>
<?'<input type="hidden" name="FT_REQUEST" value="',if val(v1001) > val(v2224)  then v3335 fi,'">'?>
<?'<input type="hidden" name="FT_PREFIX" value="',if val(v1001) > val(v2224)  then v3337 fi,'">'?>
<?if (v2227<>'') then if val(v1001) > 20 then '<input type="hidden" name="S21ALLTrm" value="',v2227,'">',fi,fi?>



</TD>

<TD> 
<input type="hidden" name="C21COM" value="S">
<input type="submit" name="C21COM1" value="~~Поиск~~">

</TD></TR>
</form>
</TABLE>

</td>
</tr>
</table>

